
[ -n "$1" ] || exit 1

umask 027
ETCDIR=/etc
CERTDIR=$ETCDIR/cert/authority/$1
CADIR=$CERTDIR/ca
CAPEMDIR=$CADIR
CAKEYDIR=$CERTDIR/cakey
REVOKEDIR=$CERTDIR/crl
SERVERCERTDIR=$CERTDIR/server
CLIENTCERTDIR=$CERTDIR/issued

DPASSWORD=12345678

case "$1" in
	radius)
		DSTATE=Radius
		DLOCALITY=STARAD
		TMPDIR=$ETCDIR/freeradius
		[ -d $TMPDIR ] || TMPDIR=$ETCDIR/freeradius3

		[ "x$DPASSWORD" = "x12345678" ] && DPASSWORD=whatever

		DHFILE=dh
	;;
	openvpn)
		DSTATE=VPN
		DLOCALITY=OpenVPN
	;;
	openconnect)
		DSTATE=VPN
		DLOCALITY=OpenConnect
	;;
	ipsec)
		DSTATE=VPN
		DLOCALITY=IPSec
		CERTDIR=$ETCDIR/swanctl
		CADIR=$CERTDIR/x509ca
		CAKEYDIR=$CERTDIR/rsa
		REVOKEDIR=$CERTDIR/x509crl
		CERTDIR=$CERTDIR/tmp
		CAPEMDIR=$CERTDIR
		SERVERCERTDIR=$CERTDIR
		CLIENTCERTDIR=$CERTDIR
	;;
	web)
		DSTATE=Web
		DLOCALITY="Web_applications"
	;;
	*)
		DSTATE="$1"
		DLOCALITY="$1"
	;;
esac

DDAYS=$(nu-getval certs:days)
[ -z "$DDAYS" ] && DDAYS=3652
DCOUNTRY=$(nu-getval certs:country)
[ -z "$DCOUNTRY" ] && DCOUNTRY=RU
DORG=$(nu-getval certs:org)
[ -z "$DORG" ] && DORG=STAsoft.net
DEMAIL=$(nu-getval certs:email)
[ -z "$EMAIL" ] && DEMAIL=info@stasoft.net
DCN="$DORG Certificate Authority"
PASSWORD=$(nu-getval certs:password)

TMPPATH=/tmp/.$DSTATE.$DLOCALITY.certs

mkdir -p $TMPPATH
