#!/bin/sh

umask 027
[ -z "$2" ] && {
	echo "Client name is required!"
	exit 1
}

SCHEMA=DNS
CERTNAME=$2
[ -n "$3" ] && SCHEMA=$3

RUNPATH=$(dirname $0)

. $RUNPATH/cert_vars.sh

[ -f $CERTDIR/index.txt ] && {
    SERIAL=$(grep $2 $CERTDIR/index.txt | awk '{ print $3; }')
    [ -n $SERIAL ] && {
	[ -f $CERTDIR/$SERIAL.pem ] && rm -f $CERTDIR/$SERIAL.pem
	grep -v $2 $CERTDIR/index.txt > $CERTDIR/index.txt
    }
}
[ -f $CERTDIR/$2.pem ] && rm -f $CERTDIR/$2.crt
[ -f $CERTDIR/$2.key ] && rm -f $CERTDIR/$2.key
[ -f $CERTDIR/$2.der ] && rm -f $CERTDIR/$2.der
[ -f $CERTDIR/$2.p12 ] && rm -f $CERTDIR/$2.p12
[ -f $CERTDIR/$2.pfx ] && rm -f $CERTDIR/$2.pfx
