#!/bin/sh

[ -z "$1" ] && exit 0

DHFILE=dh1024.pem
RUNPATH=$(dirname $0)

. $RUNPATH/cert_vars.sh

cat $RUNPATH/ca.cnf | sed -e "s,@DIR@,$CERTDIR,g" -e "s,@RDIR@,$CERTDIR,g" -e "s,@DAYS@,$DDAYS,g" -e "s,@PASSWORD@,$DPASSWORD,g" \
    -e "s,@COUNTRY@,$DCOUNTRY,g" -e "s,@ORG@,$DORG,g" -e "s,@EMAIL@,$DEMAIL,g" -e "s,@CN@,$DCN,g" \
    -e "s,@STATE@,$DSTATE,g" -e "s,@LOCALITY@,$DLOCALITY,g" > $TMPPATH/ca.cnf

rm -rf $CERTDIR/*

mkdir -p $CERTDIR
mkdir -p $CADIR
mkdir -p $CAPEMDIR
mkdir -p $CAKEYDIR

[ -f $CERTDIR/$DHFILE ] || {
  openssl dhparam -out $CERTDIR/$DHFILE 1024 || exit 1
  if [ -e /dev/urandom ] ; then
	dd if=/dev/urandom of=$CERTDIR/random count=10 >/dev/null 2>&1;
  else
	date > $CERTDIR/random;
  fi
}

openssl req -new -x509 -keyout $CAKEYDIR/ca.key -out $CADIR/ca.crt -days $DDAYS -config $TMPPATH/ca.cnf || exit 1
[ -z "$PASSWORD" ] && {
	mv -f $CAKEYDIR/ca.key $TMPPATH/ca.key
	openssl rsa -in $TMPPATH/ca.key -passin pass:$DPASSWORD -out $CAKEYDIR/ca.key
}
openssl x509 -inform PEM -outform DER -in $CADIR/ca.crt -out $CADIR/ca.der || exit 1

cp -f $CADIR/ca.crt $CAPEMDIR/ca.pem

rm -rf $TMPPATH

$RUNPATH/revokecrt.sh $1
