#!/bin/sh

RUNPATH=$(dirname $0)

. $RUNPATH/cert_vars.sh

[ -z "$2" ] && [ -f $REVOKEDIR/crl.pem ] && exit 0

cat $RUNPATH/ca.cnf | sed -e "s,@DIR@,$CERTDIR,g" -e "s,@RDIR@,$REVOKEDIR,g" -e "s,@DAYS@,$DDAYS,g" -e "s,@PASSWORD@,$DPASSWORD,g" \
    -e "s,@COUNTRY@,$DCOUNTRY,g" -e "s,@ORG@,$DORG,g" -e "s,@EMAIL@,$DEMAIL,g" -e "s,@CN@,$DCN,g" \
    -e "s,@STATE@,$DSTATE,g" -e "s,@LOCALITY@,$DLOCALITY,g" > $TMPPATH/ca.cnf

CMD="openssl ca -config $TMPPATH/ca.cnf"

if [ -f $CAKEYDIR/ca.key ]; then
	CMD="$CMD -keyfile $CAKEYDIR/ca.key"
elif [ -f $CAKEYDIR/ca.pem ]; then
	CMD="$CMD -keyfile $CAKEYDIR/ca.pem"
fi
if [ -f $CADIR/ca.pem ]; then
	CMD="$CMD -cert $CADIR/ca.pem"
elif [ -f $CADIR/ca.der ]; then
	CMD="$CMD -cert $CADIR/ca.der"
elif [ -f $CADIR/ca.crt ]; then
	CMD="$CMD -cert $CADIR/ca.crt"
fi

mkdir -p $REVOKEDIR
[ -f $REVOKEDIR/index.txt ] || touch $REVOKEDIR/index.txt
[ -f $REVOKEDIR/crlnumber ] || echo -n '00' > $REVOKEDIR/crlnumber

[ -n "$2" ] && {
    FNAME="$CLIENTCERTDIR/$2.crt"
    [ -f $FNAME ] || FNAME="$CLIENTCERTDIR/$2.pem"
    [ -f $FNAME ] || FNAME="$CLIENTCERTDIR/$2.der"

    EXT="$CMD -revoke $FNAME"
    $EXT
    rm $CLIENTCERTDIR/$2.* 2>/dev/null
}

EXT="$CMD -gencrl -out $REVOKEDIR/crl.pem"
$EXT

rm -rf $TMPPATH

