#!/bin/sh

usage() {
    echo "Usage: $0 SOURCE_PATH DESTINATION_PATH [PREFIX]"
    echo "	Example: $0 /build_dir/menu /opt/stasoft/lib/i18n/cp "
    echo "	Prefix is an optional argument"
    exit 1
}

[ -z $1 ] && usage
[ -z $2 ] && usage
PREFIX=''
[ -n "$3" ] && PREFIX=$3"_"
SRC_PATH="$1"
[ -d "$SRC_PATH" ] || usage
for LANG in $SRC_PATH/*; do
    [ -d $LANG ] && {
	LANG=$(basename $LANG)
	echo $LANG
	DST_PATH="$2/$LANG"
	[ -d "$DST_PATH" ] || mkdir -p $DST_PATH
	DST_FILE=$DST_PATH/$PREFIX"menu.str"
	[ -f $DST_FILE ] || {
	    echo "<?php" > $DST_FILE
	    echo "if (!isset(\$GLOBALS['SSX_MENU'])) {" >> $DST_FILE
	    echo "// Array containing menus" >> $DST_FILE
	    echo "\$GLOBALS['SSX_MENU']=array();" >> $DST_FILE
	    for f in $SRC_PATH/$LANG/$PREFIX*.menu; do
		[ -f "$f" ] && {
		    CTX=$(cat $f)
		    echo "\$GLOBALS['SSX_MENU']=array_merge_recursive(\$GLOBALS['SSX_MENU'],array($CTX));" >> $DST_FILE
		}
	    done
	    echo "}" >> $DST_FILE
	    echo "?>" >> $DST_FILE
	}
	DST_FILE=$DST_PATH/$PREFIX"pan.str"
	[ -f $DST_FILE ] || {
	    echo "<?php" > $DST_FILE
	    echo "if (!isset(\$GLOBALS['SSX_PAN'])) {" >> $DST_FILE
	    echo "// Array containing views" >> $DST_FILE
	    echo "\$GLOBALS['SSX_PAN']=array();" >> $DST_FILE
	    for f in $SRC_PATH/$LANG/$PREFIX*.pan; do
		[ -f "$f" ] && {
		    CTX=$(cat $f)
		    echo "\$GLOBALS['SSX_PAN'][]=$CTX;" >> $DST_FILE
		}
	    done
	    echo "}" >> $DST_FILE
	    echo "?>" >> $DST_FILE
	}
    }
done

