#!/bin/sh +e

BASE=/opt/stasoft/bin/.events
DEBUG='1'

pass_event() {
    local BASE=$1
    shift
    local FNAME

    for FNAME in $BASE/*; do
	[ -d $FNAME ] && continue
	[ -f $FNAME ] || continue
	local ff=$(basename $FNAME)
	ff=/tmp/$ff.lock
	local counter=0
	while [ -f $ff ]; do
	    [ $counter -ge 5 ] && {
		logger -p user.emerg -t event "ERROR! Lock file $ff exists!"
		return
	    }
	    sleep 1
	    counter=$(expr $counter + 1)
	done
	[ -x $FNAME ] && {
	    touch $ff
	    [ -n "$DEBUG" ] && logger -p user.notice -t event "$FNAME $*"
	    $FNAME $* >/dev/null
	    [ $? -eq 0 ] ||  logger -p user.notice -t event "handler $FNAME $* has exited with non-zero status"
	    rm -f $ff
	}
    done
}

pass_event_rec() {
    local BASE=$1
    shift

    pass_event $BASE $*
    [ -z "$1" ] && return
    BASE=$BASE/$1
    shift
    pass_event_rec $BASE $*
}

[ -f /var/lock/eevent ] && exit 0

[ -n "$1" ] || {
    logger -p user.emerg -t event "ERROR! Define event base first!"
    exit 1
}
BASE=$BASE/$1
[ -n "$2" ] || {
    logger -p user.emerg -t event "ERROR! Define event object first!. Event base is $1"
    exit 0
}
if [ "$1" = "exec" ]; then
	shift
	sleep 1
	$*
else
	shift
	[ -d $BASE ] || mkdir -p $BASE
	pass_event_rec $BASE $*
fi
