#!/bin/sh

[ -d /etc/.ssxapp ] || mkdir -p /etc/.ssxapp
PLATFORM='generic'
if [ -f /lib/hw_platform.sh ]; then
    . /lib/hw_platform.sh
    PLATFORM=$(hw_board_name)
else
    ARCH=$(grep ARCH /opt/stasoft/etc/ssxapp.ini | sed -e "s/ARCH=//g")
    [ -n "$ARCH" ] && [ -f /lib/${ARCH}.sh ] && {
	. /lib/${ARCH}.sh
	PLATFORM=$(${ARCH}_board_name)
    }
fi
ARCH=$(echo $PLATFORM | awk -F\, '{ print $2; }')
[ -n "$ARCH" ] || ARCH=$PLATFORM
PLATFORM=$ARCH
echo $PLATFORM > /etc/platform
[ -f /opt/stasoft/conf.default/$PLATFORM/main.conf ] || PLATFORM='generic'
if [ -f /opt/stasoft/conf.default/$PLATFORM/main.conf ]; then
    [ -f /etc/.ssxapp/main.conf ] && cp -f /etc/.ssxapp/main.conf /tmp/main.conf.emergency
    rm -f /etc/.ssxapp/*
    [ -f /tmp/main.conf.emergency ] && cp -f /tmp/main.conf.emergency /etc/.ssxapp/main.conf.emergency
    cp -f /opt/stasoft/conf.default/$PLATFORM/main.conf /etc/.ssxapp/
    [ -f /opt/stasoft/etc/ssxapp.ini ] && grep VERSION /opt/stasoft/etc/ssxapp.ini > /etc/version
    echo "Config was resetted to factory defaults!"
else
    echo "Factory defaults config can not be set because file not found!"
    exit 1
fi
[ -d /opt/stasoft/modules.d ] && {
    rm -rf /etc/modules.d/*
    cp -f /opt/stasoft/etc/modules.d/* /etc/modules.d/
}
[ -f /etc/cert/dropbear_dss_host_key ] && rm -f /etc/cert/dropbear_dss_host_key
[ -f /etc/cert/dropbear_rsa_host_key ] && rm -f /etc/cert/dropbear_rsa_host_key
[ -f /etc/cert/ssh_host_rsa_key ] && rm -f /etc/cert/ssh_host_rsa_key
[ -f /etc/frr/frr.conf ] && echo ' ' > /etc/frr/frr.conf
[ -f /etc/quagga/Quagga.conf ] && echo ' ' > /etc/quagga/Quagga.conf
[ -d /etc/cert/authority ] && rm -rf /etc/cert/authority
if [ -f /usr/lib/php/pdo_sqlite.so ]; then
    rm -rf /mnt/data/sqlite
    [ -x /opt/stasoft/contrib/prep_all.sh ] && /opt/stasoft/contrib/prep_all.sh sqlite netshe netshe netshe
fi
sync
[ -x /opt/stasoft/bin/resetrpw.php ] && /opt/stasoft/bin/resetrpw.php
[ -x /opt/stasoft/bin/restore_schedule.php ] && /opt/stasoft/bin/restore_schedule.php
[ -z "$1" ] && [ -x /opt/stasoft/bin/event.sh ] && /opt/stasoft/bin/event.sh config new
