#!/usr/bin/php-cgi
<?php

error_reporting(E_ALL);

require_once(dirname(__FILE__).'/../../lib/www-lib.inc');

class indexer extends Dispatcher
{

    public function __construct() {
	parent::__construct(array('appname'=>'cp', 'menu'=>'emp_menu'));
    }

    private function move_permanent($arr=array()) {
	header("HTTP/1.1 301 Moved Permanently");
	header("Location: ".$arr['url']);
    }

    private function show_none() {
	header('Content-type: text/html');
    }

    private function print_links($arr=array()) {
	$this->show_none();
	print("<!doctype html>
<html lang=\"en\">
<head>
<meta name=\"viewport\" content=\"width=device-width, initial-scale=1.0\">
<title>Select application</title>
</head>
<body>
<style>
a, a:link, a:visited {
    font-family: arial, helvetica, freesans, sans-serif;
    font-size:32px;
    text-decoration:none;
    padding:4px;
    color:darkblue;
    display:inline-block;
}
a:hover {
    color:white;
    background-color:darkblue;
}
a:active {
    color:white;
    background-color:darkgray;
}
.centered {
    position: fixed;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
    text-align: center;
}
</style>
<div class=\"centered\">");
	for ($i = 0; $i < count($arr); $i ++)
	    print("<a href=\"".$arr[$i]['url']."\">".$arr[$i]['desc']."</a><br /><br />\n");
	print("</div>
</body>
</html>");
    }

    private function show($links=array()) {
	ob_start();
	switch (count($links)) {
	    case 0:
		$this->show_none();
	    break;
	    case 1:
		$this->move_permanent($links[0]);
	    break;
	    default:
		$this->print_links($links);
	    break;
	}
	ob_flush();
    }

    private function create_all_app_links($path='./', &$links=array()) {
	$url = '';
	$desc = '';
	if (($handle = opendir($path))) {
	    while (false !== ($entry = readdir($handle))) {
		if (($entry == 'tmp') || ($entry == 'nms') || ($entry == 'files') || ($entry == 'auth') || ($entry == 'select') || ($entry == 'vpi'))
		    continue;
		if (is_dir($path.$entry)) {
		    if (substr($entry, 0, 1) == '.')
			continue;
		    $this->create_all_app_links($path.$entry.'/', $links);
		} else {
		    if ($path == './')
			continue;
		    if ($entry == '.hidden') {
			$url = '';
			break;
		    }
		    if ($entry == '.desc')
			$desc = file_get_contents($path.$entry);
		    if ($entry == 'index.php')
			$url = '/app/'.str_replace('./','', $path).'index.php';
		}
	    }
	    if (!empty($url)) {
		if (empty($desc))
		    $desc = $url;
		$links[] = array('url' => $url, 'desc' => $desc);
	    }
	    closedir($handle);
	}
    }

    public function exec() {
	$path = './';
	$links = array();
	if (empty($this->config['PRIVATE_KEY']) && file_exists('./wzrd/index.php')) {
	    $links = array(0 => array('url' => '/app/wzrd/index.php', 'desc' => ''));
	} else if (!empty($this->config['default_view']) && file_exists('./'.$this->config['default_view'].'/index.php')) {
	    $links = array(0 => array('url' => '/app/'.$this->config['default_view'].'/index.php', 'desc' => 'Enter application'));
	} else {
	    $this->create_all_app_links($path, $links);
	}
	$this->show($links);
    }
}

$app = new indexer;
$app->exec();

?>
