
CREATE TABLE sk_system_conf (
  conf_id serial8 PRIMARY KEY,
  "type" int4 NOT NULL default '0' CHECK ("type" >= 0),
  attribute VARCHAR(128) NOT NULL default '',
  value TEXT NOT NULL default '',
  provider_id int8 NOT NULL default '0' CHECK (provider_id >= 0),
  service_id int8 NOT NULL DEFAULT '0' CHECK (service_id >= 0),
  obj_id int8 NOT NULL default '0' CHECK (obj_id >= 0),
  active CHAR(1) NOT NULL default 'Y' CHECK (active = 'Y' OR active = 'N')
);

CREATE TABLE sk_history (
  "date_time" timestamp without time zone not null default '1970-01-01 00:00',
  "type" int4 NOT NULL DEFAULT '0',
  access_from text,
  access_to text,
  auth_name text,
  auth_info text,
  "comment" text
) WITHOUT OIDS;

CREATE TABLE sk_history_01 ( CONSTRAINT "$1" CHECK (extract(month from date_time)=1)) INHERITS (sk_history) WITHOUT OIDS;
CREATE TABLE sk_history_02 ( CONSTRAINT "$1" CHECK (extract(month from date_time)=2)) INHERITS (sk_history) WITHOUT OIDS;
CREATE TABLE sk_history_03 ( CONSTRAINT "$1" CHECK (extract(month from date_time)=3)) INHERITS (sk_history) WITHOUT OIDS;
CREATE TABLE sk_history_04 ( CONSTRAINT "$1" CHECK (extract(month from date_time)=4)) INHERITS (sk_history) WITHOUT OIDS;
CREATE TABLE sk_history_05 ( CONSTRAINT "$1" CHECK (extract(month from date_time)=5)) INHERITS (sk_history) WITHOUT OIDS;
CREATE TABLE sk_history_06 ( CONSTRAINT "$1" CHECK (extract(month from date_time)=6)) INHERITS (sk_history) WITHOUT OIDS;
CREATE TABLE sk_history_07 ( CONSTRAINT "$1" CHECK (extract(month from date_time)=7)) INHERITS (sk_history) WITHOUT OIDS;
CREATE TABLE sk_history_08 ( CONSTRAINT "$1" CHECK (extract(month from date_time)=8)) INHERITS (sk_history) WITHOUT OIDS;
CREATE TABLE sk_history_09 ( CONSTRAINT "$1" CHECK (extract(month from date_time)=9)) INHERITS (sk_history) WITHOUT OIDS;
CREATE TABLE sk_history_10 ( CONSTRAINT "$1" CHECK (extract(month from date_time)=10)) INHERITS (sk_history) WITHOUT OIDS;
CREATE TABLE sk_history_11 ( CONSTRAINT "$1" CHECK (extract(month from date_time)=11)) INHERITS (sk_history) WITHOUT OIDS;
CREATE TABLE sk_history_12 ( CONSTRAINT "$1" CHECK (extract(month from date_time)=12)) INHERITS (sk_history) WITHOUT OIDS;

CREATE OR REPLACE RULE hist_ins_01 AS ON INSERT TO sk_history WHERE extract(month from new.date_time) = 1 DO INSTEAD
INSERT INTO sk_history_01 (date_time,type,access_from,access_to,auth_name,auth_info,comment) VALUES(NEW.date_time,NEW.type,
NEW.access_from,NEW.access_to,NEW.auth_name,NEW.auth_info,NEW.comment);

CREATE OR REPLACE RULE hist_ins_02 AS ON INSERT TO sk_history WHERE extract(month from new.date_time) = 2 DO INSTEAD
INSERT INTO sk_history_02 (date_time,type,access_from,access_to,auth_name,auth_info,comment) VALUES(NEW.date_time,NEW.type,
NEW.access_from,NEW.access_to,NEW.auth_name,NEW.auth_info,NEW.comment);

CREATE OR REPLACE RULE hist_ins_03 AS ON INSERT TO sk_history WHERE extract(month from new.date_time) = 3 DO INSTEAD
INSERT INTO sk_history_03 (date_time,type,access_from,access_to,auth_name,auth_info,comment) VALUES(NEW.date_time,NEW.type,
NEW.access_from,NEW.access_to,NEW.auth_name,NEW.auth_info,NEW.comment);

CREATE OR REPLACE RULE hist_ins_04 AS ON INSERT TO sk_history WHERE extract(month from new.date_time) = 4 DO INSTEAD
INSERT INTO sk_history_04 (date_time,type,access_from,access_to,auth_name,auth_info,comment) VALUES(NEW.date_time,NEW.type,
NEW.access_from,NEW.access_to,NEW.auth_name,NEW.auth_info,NEW.comment);

CREATE OR REPLACE RULE hist_ins_05 AS ON INSERT TO sk_history WHERE extract(month from new.date_time) = 5 DO INSTEAD
INSERT INTO sk_history_05 (date_time,type,access_from,access_to,auth_name,auth_info,comment) VALUES(NEW.date_time,NEW.type,
NEW.access_from,NEW.access_to,NEW.auth_name,NEW.auth_info,NEW.comment);

CREATE OR REPLACE RULE hist_ins_06 AS ON INSERT TO sk_history WHERE extract(month from new.date_time) = 6 DO INSTEAD
INSERT INTO sk_history_06 (date_time,type,access_from,access_to,auth_name,auth_info,comment) VALUES(NEW.date_time,NEW.type,
NEW.access_from,NEW.access_to,NEW.auth_name,NEW.auth_info,NEW.comment);

CREATE OR REPLACE RULE hist_ins_07 AS ON INSERT TO sk_history WHERE extract(month from new.date_time) = 7 DO INSTEAD
INSERT INTO sk_history_07 (date_time,type,access_from,access_to,auth_name,auth_info,comment) VALUES(NEW.date_time,NEW.type,
NEW.access_from,NEW.access_to,NEW.auth_name,NEW.auth_info,NEW.comment);

CREATE OR REPLACE RULE hist_ins_08 AS ON INSERT TO sk_history WHERE extract(month from new.date_time) = 8 DO INSTEAD
INSERT INTO sk_history_08 (date_time,type,access_from,access_to,auth_name,auth_info,comment) VALUES(NEW.date_time,NEW.type,
NEW.access_from,NEW.access_to,NEW.auth_name,NEW.auth_info,NEW.comment);

CREATE OR REPLACE RULE hist_ins_09 AS ON INSERT TO sk_history WHERE extract(month from new.date_time) = 9 DO INSTEAD
INSERT INTO sk_history_09 (date_time,type,access_from,access_to,auth_name,auth_info,comment) VALUES(NEW.date_time,NEW.type,
NEW.access_from,NEW.access_to,NEW.auth_name,NEW.auth_info,NEW.comment);

CREATE OR REPLACE RULE hist_ins_10 AS ON INSERT TO sk_history WHERE extract(month from new.date_time) = 10 DO INSTEAD
INSERT INTO sk_history_10 (date_time,type,access_from,access_to,auth_name,auth_info,comment) VALUES(NEW.date_time,NEW.type,
NEW.access_from,NEW.access_to,NEW.auth_name,NEW.auth_info,NEW.comment);

CREATE OR REPLACE RULE hist_ins_11 AS ON INSERT TO sk_history WHERE extract(month from new.date_time) = 11 DO INSTEAD
INSERT INTO sk_history_11 (date_time,type,access_from,access_to,auth_name,auth_info,comment) VALUES(NEW.date_time,NEW.type,
NEW.access_from,NEW.access_to,NEW.auth_name,NEW.auth_info,NEW.comment);

CREATE OR REPLACE RULE hist_ins_12 AS ON INSERT TO sk_history WHERE extract(month from new.date_time) = 12 DO INSTEAD
INSERT INTO sk_history_12 (date_time,type,access_from,access_to,auth_name,auth_info,comment) VALUES(NEW.date_time,NEW.type,
NEW.access_from,NEW.access_to,NEW.auth_name,NEW.auth_info,NEW.comment);
