#!/bin/sh

[ -z "$1" ] && exit 1

DATAPATH=/mnt/data/sqlite
[ -d $DATAPATH ] || mkdir -p $DATAPATH
FNAME=${DATAPATH}/${1}
ACNAME="mnt\/data\/sqlite\/${1}"

echo "Insert data into database"

for f in /opt/stasoft/contrib/data/sqlite/*.sql; do
    echo -n "Process $f "
    sqlite3 $FNAME < $f
    if [ "$?" = "0" ]; then
	echo "ok"
    else
	echo "error"
	break
    fi
done

FNAME=/opt/stasoft/bin/apply_profile.php
[ -x $FNAME ] && {
    echo "{\"cfg\":{\"DB\":{\"DEBUG\":0,\"TRANSACTION\":1,\"URI\":\"sqlite:\/\/localhost\/$ACNAME\"}}}" > /tmp/.main.sqlite.conf
    $FNAME /tmp/.main.sqlite.conf
    rm -f /tmp/.main.sqlite.conf
}

[ -f /etc/php.ini -a ! -d /etc/php7 ] && {
    grep -v pdo /etc/php.ini > /tmp/.php.ini
    echo "extension=pdo.so
extension=pdo_sqlite.so" >> /tmp/.php.ini
    mv -f /tmp/.php.ini /etc/php.ini
}
