#!/bin/sh

[ -z "$4" ] && exit 1

PREFIX=$1

shift

CMD="/opt/stasoft/contrib/data/${PREFIX}_prep_db.sh"

if [ -x $CMD ]; then
    $CMD $*
else
    echo "Did not find DB creator"
    exit 1
fi

for file in /opt/stasoft/contrib/data/3party/*; do
    [ -x $file ] && $file $*
done

TZ=$(cat /etc/TZ)
if [ -d /etc/php7 ]; then
    echo "[Date]" >> /etc/php.ini
else
    echo "register_globals = On
[Date]" >> /etc/php.ini
fi
if [ "$TZ" = "MSK" ]; then
    echo "date.timezone=Europe/Moscow" >> /etc/php.ini
else
    echo "date.timezone=UTC" >> /etc/php.ini
fi
