<?php
 require_once(dirname(__FILE__).'/../lib/util-lib.inc'); function copy_scp( $local, $remote, $username, $pass, $host, $limit=0, $port=22) { if ( empty($port)) $port = 22; if (!file_exists($local) || empty($remote) || empty($username) || empty($pass) || !is_hostname($host) || !is_numeric($limit) || !is_port($port)) return false; $lstr = ''; if ( $limit > 0) $lstr = '-l '.$limit; $pstr = ''; if ( $port != 22) $pstr = '-P'.$port; if ( substr($remote, 0, 1) != '/') $remote = '/'.$remote; $res = 0; $ret = array(); exec('scp -v -B '.$lstr.' '.$pstr.' '.$local.' '.$username.'@'.$host.':'.$remote, $ret, $res); return ($res == 0); } function copy_rsync( $local, $remote, $username, $pass, $host, $limit=0, $port=873) { if ( empty($port)) $port = 873; if (!file_exists($local) || empty($remote) || empty($username) || empty($pass) || !is_hostname($host) || !is_numeric($limit) || !is_port($port)) return false; if ( $limit > 0) $limit = int($limit/8); if ( substr($remote, 0, 1) != '/') $remote = '/'.$remote; return (mwexec(dirname(__FILE__).'/../bin/rsynccw '.$username.' '.$pass.' '.$host.' '.$local.' '.$remote.' '.$limit.' '.$port) == 0); } function copy_ftp( $local, $remote, $username, $pass, $host, $limit=0, $port=21) { $res = false; if ( empty($port)) $port = 21; if (!file_exists($local) || empty($remote) || empty($username) || empty($pass) || !is_hostname($host) || !is_numeric($limit) || !is_port($port)) return $res; if ( (strlen( $remote) > 1) && substr( $remote, strlen( $remote)-1, 1) !== '/') $remote .= '/'; $res = (mwexec('nu-put', 'ftp://'.$username.':'.$pass.'@'.$host.':'.$port.'/'.$remote.' '.$local) == 0); return $res; } function copy_mapped( $local, $remote, $map_path) { if (!file_exists($local) || empty($remote) || empty($map_path)) return false; if ( substr($map_path, 0, 1) != '/') $map_path = '/'.$map_path; if ( !file_exists($map_path.$remote)) make_dirs($map_path.$remote); return copy_recursive($local, $map_path.$remote); } function pmysql_backup_db( $superuser, $superpass, $dbname, $path, $compressor="bz2") { if ( empty($superuser) || empty($superpass) || empty($dbname) || empty($path)) return ''; $cmd = ''; if ( $compressor == "bz2") $cmd = ' | bzip2 -cf '; elseif ($compressor == "gz") $cmd = ' | gzip -cf '; else $compressor = ''; $hostname = chostname(); $fname = $hostname.'.'.strftime('%Y-%m-%d').'.'.$dbname.'.dump.'; $res = 0; $ret = array(); exec('mysqldump --add-drop-table --opt -u'.$superuser.' -p'.$superpass.' '.$dbname.$cmd.' > '.$path.$fname.$compressor, $ret, $res); $fqfn = $path.$fname.$compressor; if ( ($res == 0) && file_exists($fqfn)) return $fqfn; return ""; } function pmysql_backup_all( $superuser, $superpass, $path, $compressor='bz2') { if ( empty($superuser) || empty($superpass) || empty($path)) return ''; $cmd = ''; if ( $compressor == "bz2") $cmd = ' | bzip2 -cf '; elseif ($compressor == "gz") $cmd = ' | gzip -cf '; else $compressor = ''; $hostname = chostname(); $fname = $hostname.strftime('%Y-%m-%d').'.dump.'; $res = 0; system('mysqldump --add-drop-table --opt --all -u'.$superuser.' -p'.$superpass.' '.$dbname.$cmd.' > '.$path.$fname.$compressor, $res); $fqfn = $path.$fname.$compressor; if ( ($res == 0) && file_exists($fqfn)) return $fqfn; return ""; } function pmysql_list_db( $superuser, $superpass) { $outa = array(); if ( empty($superuser) || empty($superpass)) return $outa; $outv = exec_command_and_return_text_array('mysqlshow', ' -u'.$superuser.' -p'.$superpass); if ( count($outv) > 3) { $j = 0; for ( $i = 3; $i < count($outv)-1; $i++) { $larr = preg_split("/[\s]+/", $outv[$i]); if ( !empty($larr[1])) { $outa[$j] = $larr[1]; $j ++; } } } return $outa; } function pmysql_repair_db( $superuser, $superpass, $dbname) { if ( empty($superuser) || empty($superpass) || empty($dbname)) return false; return (mwexec('mysqlcheck',' -u'.$superuser.' -p'.$superpass.' -aor --auto-repair '.$dbname) == 0); } function pmysql_db_size( $superuser, $superpass, $dbname) { return 0; } function ppgsql_backup_db( $superuser, $superpass, $dbname, $path, $compressor='bz2') { if ( empty($superuser) || empty($superpass) || empty($dbname) || empty($path)) return ''; $cmd = ''; if ( $compressor == "bz2") $cmd = ' | bzip2 -cf '; elseif ($compressor == "gz") $cmd = ' | gzip -cf '; else $compressor = ''; $hostname = chostname(); $fname = $hostname.'.'.strftime('%Y-%m-%d').'.'.$dbname.'.dump.'; $res = 0; $ret = array(); exec(dirname(__FILE__).'/../bin/pgdumpw '.$superuser.' '.$superpass.' '.$dbname.$cmd.' > '.$path.$fname.$compressor, $ret, $res); $fqfn = $path.$fname.$compressor; if ( ($res == 0) && file_exists($fqfn)) return $fqfn; return ""; } function ppgsql_backup_all( $superuser, $superpass, $path, $compressor='bz2') { if ( empty($superuser) || empty($superpass) || empty($path)) return ''; $cmd = ''; if ( $compressor == "bz2") $cmd = ' | bzip2 -cf '; elseif ($compressor == "gz") $cmd = ' | gzip -cf '; else $compressor = ''; $hostname = chostname(); $fname = $hostname.strftime('%Y-%m-%d').'.dump.'; $res = 0; $ret = array(); exec(dirname(__FILE__).'/../bin/pgdumpallw '.$superuser.' '.$superpass.' '.$dbname.$cmd.' > '.$path.$fname.$compressor, $ret, $res); $fqfn = $path.$fname.$compressor; if ( ($res == 0) && file_exists($fqfn)) return $fqfn; return ''; } function ppgsql_list_db( $superuser, $superpass) { if ( empty($superuser) || empty($superpass)) return $outa; $outa = array(); $outv = exec_command_and_return_text_array(dirname(__FILE__).'/../bin/pglistdb '.$superuser.' '.$superpass); if ( $outv) { $j = 0; for ( $i = 0; $i < count($outv); $i++) { $larr = preg_split("/[\s]+/", $outv[$i]); if ( !empty($larr[1])) { $outa[$j] = $larr[1]; $j ++; } } } return $outa; } function ppgsql_repair_db( $superuser, $superpass, $dbname) { if ( empty($superuser) || empty($superpass) || empty($dbname)) return false; $contents = "SET zero_damaged_pages=true;\nVACUUM FULL ANALYZE;\nREINDEX DATABASE $dbname;"; $fname = get_tmp_file(); file_put_contents( $fname, $contents); if ( !file_exists($fname)) return false; $res = mwexec(dirname(__FILE__).'/../bin/pgexecw '.$superuser.' '.$superpass.' '.$dbname.' '.$fname); unlink_if_exists( $fname); return ($res == 0); } function ppgsql_db_size( $superuser, $superpass, $dbname) { if ( empty($superuser) || empty($superpass) || empty($dbname)) return 0; $contents = "SELECT pg_database_size('".$dbname."');"; $fname = get_tmp_file(); file_put_contents( $fname, $contents); if ( !file_exists($fname)) return false; $res = 0; $outv = exec_command_and_return_text_array(dirname(__FILE__).'/../bin/pgexecw '.$superuser.' '.$superpass.' '.$dbname.' '.$fname, $res); unlink_if_exists( $fname); if ( $outv && (count($outv)>2)) { $larr = preg_split("/[\s]+/", $outv[2]); if ( !empty($larr[1])) { $res = $larr[1]; } } return $res; } function initial_backup($path, $dir, $excl=array()) { rmdir_recursive($path.'/current/'.$dir); make_dirs( $path.'/current/'.$dir); $cmd = ''; for ( $i = 0; $i < count($excl); $i ++) $cmd .= ' --exclude='.$excl[$i]; return (mwexec('rsync -aqR '.$cmd.' '.$dir.' '.$path.'/current') == 0); } function daily_backup( $path, $dir, $nod, $excl=array()) { $cmd = 'rsync -aqR --compare-dest='.$path.'/current '; for ( $i = 1; $i < $nod; $i++) { $lpath = $path.sprintf("/%d", $i); if ( file_exists($lpath)) $cmd .= '--compare-dest='.$lpath.' '; } for ( $i = 0; $i < count($excl); $i ++) $cmd .= '--exclude='.$excl[$i].' '; $cmd .= $dir.' '; $lpath = $path.sprintf("/%d/", $nod); rmdir_recursive( $lpath.$dir); make_dirs( $lpath); $cmd .= $lpath; return (mwexec($cmd) == 0); } function compile_snapshot( $path, $dir) { for ( $i = 1; $i < 7; $i++) { $lpath = $path.sprintf("/%d/", $i).$dir; if ( file_exists($lpath)) { copy_recursive( $lpath, $path.'/current/'.$dir); rmdir_recursive($lpath); } } } function pack_snapshot( $path, $dir, $compressor) { $fname = ''; $ldir = str_replace( '/', '_', $dir); $cwd = getcwd(); chdir($path.'/current'); if (mwexec('tar -cvvf /tmp/'.$ldir.'.tar '.$dir) == 0) { chdir('/tmp'); if ( $compressor == 'gz') { if ( mwexec('gzip /tmp/'.$ldir.'.tar') == 0) $fname = '/tmp/'.$ldir.'.tar.gz'; } elseif ( $compressor == 'bz2') { if ( mwexec('bzip2 /tmp/'.$ldir.'.tar') == 0) $fname = '/tmp/'.$ldir.'.tar.bz2'; } } chdir($cwd); return $fname; } class BackupWorker extends SSXApp { var $path; var $compressor; var $user; var $pass; var $dbtype; var $do_upload = false; var $upload_host; var $upload_port = ''; var $upload_limit = 0; var $upload_method; var $upload_uname; var $upload_pass; function __construct() { parent::__construct( array('appname'=>'cp')); $this->classname = 'backup'; $this->load_string_resource('backup'); if ( isset( $this->config['backup']['upload']['do'])) $this->do_upload = $this->config['backup']['upload']['do']; if ( $this->do_upload) { if ( isset($this->config['backup']['upload']['method'])) $this->upload_method = $this->config['backup']['upload']['method']; else { $this->log(CMMN_ERROR, STR_BACKUP_MAIL_HEADER, __FILE__, __LINE__, '', STR_BACKUP_VARIABLE_NOT_SET); exit(1); } if ( isset($this->config['backup']['upload']['host'])) $this->upload_host = $this->config['backup']['upload']['host']; else { $this->log(CMMN_ERROR, STR_BACKUP_MAIL_HEADER, __FILE__, __LINE__, '', STR_BACKUP_VARIABLE_NOT_SET); exit(1); } if ( $this->upload_method == 'rsync' || $this->upload_method == 'scp' || $this->upload_method == 'ftp') { if ( isset($this->config['backup']['upload']['port'])) $this->upload_port = $this->config['backup']['upload']['port']; else $this->upload_port = 0; if ( isset($this->config['backup']['upload']['username'])) $this->upload_uname = $this->config['backup']['upload']['username']; else { $this->log(CMMN_ERROR, STR_BACKUP_MAIL_HEADER, __FILE__, __LINE__, '', STR_BACKUP_VARIABLE_NOT_SET); exit(1); } if ( isset($this->config['backup']['upload']['password'])) $this->upload_pass = $this->config['backup']['upload']['password']; else { $this->log(CMMN_ERROR, STR_BACKUP_MAIL_HEADER, __FILE__, __LINE__, '', STR_BACKUP_VARIABLE_NOT_SET); exit(1); } if ( isset($this->config['backup']['upload']['limit'])) $this->upload_limit = $this->config['backup']['upload']['limit']; else $this->upload_limit = 0; } } if ( isset($this->config['backup']['SEND_SPACE_EMAIL_BEFORE'])) { $txt = exec_command_and_return_text_array('df -h'); $email_msg = ''; for ( $i = 0; $i < count($txt); $i++) $email_msg .= $txt[$i]."\n\r"; $this->log( CMMN_ERROR, STR_BACKUP_SPACEREPORT_BEFORE, __FILE__, __LINE__, '', $email_msg); } return $this; } function copy( $local, $remote) { if ( $this->do_upload) { if ( isset($this->config['backup']['upload']['do_cmd_before'])) { $txt = exec_command_and_return_text_array($this->config['backup']['upload']['do_cmd_before']); if ( !empty($txt)) $this->log( CMMN_ERROR, 'Command has retured text', __FILE__, __LINE__, '', $txt); } $res = true; switch ( strtolower($this->upload_method)) { case 'scp': $res = copy_scp( $local, $remote, $this->upload_uname, $this->upload_pass, $this->upload_host, $this->upload_limit, $this->upload_port); break; case 'rsync': $res = copy_rsync( $local, $remote, $this->upload_uname, $this->upload_pass, $this->upload_host, $this->upload_limit, $this->upload_port); break; case 'ftp': $res = copy_ftp( $local, $remote, $this->upload_uname, $this->upload_pass, $this->upload_host, $this->upload_limit, $this->upload_port); break; default: $res = copy_mapped( $local, $remote, $this->upload_host); break; } if ( !$res) $this->log( CMMN_ERROR, STR_BACKUP_MAIL_HEADER, __FILE__, __LINE__, '', sprintf(STR_BACKUP_RCOPY_ERROR, $local, $remote)); else { if ( isset($this->config['backup']['upload']['DELETE_LOCAL_AFTER'])) unlink($local); } if ( isset($this->config['backup']['upload']['do_cmd_after'])) { $txt = exec_command_and_return_text_array($this->config['backup']['upload']['do_cmd_after']); if ( !empty($txt)) $this->log( CMMN_ERROR, 'Command has retured text', __FILE__, __LINE__, '', $txt); } } } public function all() { reset( $this->config['backup']); foreach($this->config['backup'] as $key=>$value) { if ( ($key == 'mysql') || ($key == 'pgsql')) { if ( is_array($value)) { reset($value); $this->user = $value['username']; $this->pass = $value['password']; $this->path = $value['path']; $this->compressor = $value['compressor']; $this->db_exec( strtolower($key)); } } } reset( $this->config['backup']); $this->path = $this->config['backup']['data']['path']; $this->compressor = $this->config['backup']['data']['compressor']; $dirs = explode(" ", $this->config['backup']['data']['dirs']); for ( $i = 0; $i < count($dirs); $i ++) { $excl = array(); if ( isset( $this->config['backup']['data'][$dirs[$i]])) $excl = preg_split("/[\s,]+/", $this->config['backup']['data'][$dirs[$i]]); $this->data_exec( $dirs[$i], $excl); } if ( isset($this->config['backup']['SEND_SPACE_EMAIL_AFTER'])) { $txt = exec_command_and_return_text_array('df -h'); $email_msg = ''; for ( $i = 0; $i < count($txt); $i++) $email_msg .= $txt[$i]."\n\r"; $this->log( CMMN_ERROR, STR_BACKUP_SPACEREPORT_AFTER, __FILE__, __LINE__, '', $email_msg); } } function data_exec( $dir='', $excl=array()) { if ( empty( $dir)) return ; $day=intval(date('j')); $mon=intval(date('n')); $year=intval(date('Y')); $nod=intval(date('w')); $first_time = false; $do_year_copy = ((($mon==1) && ($day==1) || !is_dir($this->path.'/last.year'.$dir))); $do_mon_copy = (($day==1) || !is_dir($this->path.'/last.month'.$dir)); $first_time = $do_year_copy || $do_mon_copy; if ( !file_exists( $this->path.'/current'.$dir)) { make_dirs( $this->path.'/current'.$dir, 0700); if ( !initial_backup( $this->path, $dir, $excl)) $this->log( CMMN_ERROR, STR_BACKUP_MAIL_HEADER, __FILE__, __LINE__, '', STR_BACKUP_INITIAL_ERROR); $first_time = true; } if ( ($nod == 0) || $first_time) { compile_snapshot($this->path, $dir); $fname = pack_snapshot( $this->path, $dir, $this->compressor); if ( empty($fname)) $this->log( CMMN_ERROR, STR_BACKUP_MAIL_HEADER, __FILE__, __LINE__, '', sprintf(STR_BACKUP_COMPRESS_ERROR, $file)); else $this->copy( $fname, $this->path.'/'.$this->hostname.'/'); if ( is_dir( $this->path.'/last.week'.$dir)) { rmdir_recursive( $this->path.'/prev.week'.$dir); make_dirs( $this->path.'/prev.week', 0700); rename( $this->path.'/last.week'.$dir, $this->path.'/prev.week'.$dir); } make_dirs( $this->path.'/last.week'.$dir, 0700); if ( !empty($fname)) { if ( !copy_recursive($fname, $this->path.'/last.week'.$dir.'/')) $this->log( CMMN_ERROR, STR_BACKUP_MAIL_HEADER, __FILE__, __LINE__, '', sprintf(STR_BACKUP_COPY_ERROR, $fname)); unlink_if_exists( $fname); } if ( !$first_time) { rmdir_recursive( $this->path.'/current'.$dir); make_dirs( $this->path.'/current'.$dir, 0700); if ( !initial_backup( $this->path, $dir, $excl)) $this->log( CMMN_ERROR, STR_BACKUP_MAIL_HEADER, __FILE__, __LINE__, '', STR_BACKUP_INITIAL_ERROR); } } else { if ( !daily_backup($this->path, $dir, $nod, $excl)) $this->log( CMMN_ERROR, STR_BACKUP_MAIL_HEADER, __FILE__, __LINE__, '', STR_BACKUP_DAILY_ERROR); } if ( $do_year_copy) { if ( is_dir( $this->path.'/last.year'.$dir)) { rmdir_recursive( $this->path.'/prev.year'.$dir); make_dirs( $this->path.'/prev.year', 0700); rename( $this->path.'/last.year'.$dir, $this->path.'/prev.year'.$dir); } make_dirs( $this->path.'/last.year'.$dir, 0700); if ( !copy_recursive($this->path.'/last.week'.$dir, $this->path.'/last.year')) $this->log( CMMN_ERROR, STR_BACKUP_MAIL_HEADER, __FILE__, __LINE__, '', sprintf(STR_BACKUP_COPY_ERROR, '*')); } if ( $do_mon_copy) { if ( is_dir( $this->path.'/last.month'.$dir)) { rmdir_recursive( $this->path.'/prev.month'.$dir); make_dirs( $this->path.'/prev.month', 0700); rename( $this->path.'/last.month'.$dir, $this->path.'/prev.month'.$dir); } make_dirs( $this->path.'/last.month'.$dir, 0700); if ( !copy_recursive($this->path.'/last.week'.$dir, $this->path.'/last.month')) $this->log( CMMN_ERROR, STR_BACKUP_MAIL_HEADER, __FILE__, __LINE__, '', sprintf(STR_BACKUP_COPY_ERROR, '*')); } } function db_exec( $dbtype) { $day=intval(date('j')); $mon=intval(date('n')); $year=intval(date('Y')); $nod=intval(date('w')); $fname = $this->hostname.'.'.strftime('%Y-%m-%d').'.'; $old_fname = $this->hostname.'.'.strftime('%Y-%m-%d', (time()-691200)).'.'; $do_year_copy = ((($mon==1) && ($day==1)) || !file_exists($this->path.'/'.$dbtype.'/last.year')); $do_mon_copy = (($day==1) || !file_exists($this->path.'/'.$dbtype.'/last.month')); $do_week_copy = (($nod==0) || !file_exists($this->path.'/'.$dbtype.'/last.week')); make_dirs( $this->path.'/'.$dbtype.'/current/', 0700); if ( ($dbtype === 'mysql') && !empty($this->user) && !empty($this->pass)) { if (($a = pmysql_list_db($this->user, $this->pass))) { for ( $i = 0; $i < count($a); $i ++) { $aname = pmysql_backup_db($this->user, $this->pass, $a[$i], $this->path.'/'.$dbtype.'/current/', $this->compressor); if ( empty($aname)) $this->log( CMMN_ERROR, STR_BACKUP_MAIL_HEADER, __FILE__, __LINE__, '', sprintf(STR_BACKUP_MYSQLBACKUP_ERROR, $a[$i])); else $this->copy( $aname, $this->path.'/'.$dbtype.'/'.$this->hostname.'/'); } } else $this->log( CMMN_ERROR, STR_BACKUP_MAIL_HEADER, __FILE__, __LINE__, '', STR_BACKUP_MYSQLDBLIST_ERROR); } elseif ( ($dbtype === 'pgsql') && !empty($this->user) && !empty($this->pass)) { if (($a = ppgsql_list_db($this->user, $this->pass))) { for ( $i = 0; $i < count($a); $i ++) { $aname = ppgsql_backup_db($this->user, $this->pass, $a[$i], $this->path.'/'.$dbtype.'/current/', $this->compressor); if ( empty($aname)) $this->log( CMMN_ERROR, STR_BACKUP_MAIL_HEADER, __FILE__, __LINE__, '', sprintf(STR_BACKUP_PGSQLBACKUP_ERROR, $a[$i])); else $this->copy( $aname, $this->path.'/'.$dbtype.'/'.$this->hostname.'/'); } } else $this->log( CMMN_ERROR, STR_BACKUP_MAIL_HEADER, __FILE__, __LINE__, '', STR_BACKUP_PGSQLDBLIST_ERROR); } if ( $do_year_copy) { if ( file_exists( $this->path.'/'.$dbtype.'/last.year')) { rmdir_recursive( $this->path.'/'.$dbtype.'/prev.year'); rename( $this->path.'/'.$dbtype.'/last.year', $this->path.'/'.$dbtype.'/prev.year'); } make_dirs( $this->path.'/'.$dbtype.'/last.year/', 0700); if ( !copy_recursive($this->path.'/'.$dbtype.'/current/'.$fname, $this->path.'/'.$dbtype.'/last.year/')) $this->log( CMMN_ERROR, STR_BACKUP_MAIL_HEADER, __FILE__, __LINE__, '', sprintf(STR_BACKUP_COPY_ERROR, $fname)); } if ( $do_mon_copy) { if ( file_exists( $this->path.'/'.$dbtype.'/last.month')) { rmdir_recursive( $this->path.'/'.$dbtype.'/prev.month'); rename( $this->path.'/'.$dbtype.'/last.month', $this->path.'/'.$dbtype.'/prev.month'); } make_dirs( $this->path.'/'.$dbtype.'/last.month/', 0700); if ( !copy_recursive($this->path.'/'.$dbtype.'/current/'.$fname, $this->path.'/'.$dbtype.'/last.month/')) $this->log( CMMN_ERROR, STR_BACKUP_MAIL_HEADER, __FILE__, __LINE__, '', sprintf(STR_BACKUP_COPY_ERROR, $fname)); } if ( $do_week_copy) { if ( file_exists( $this->path.'/'.$dbtype.'/last.week')) { rmdir_recursive( $this->path.'/'.$dbtype.'/prev.week'); rename( $this->path.'/'.$dbtype.'/last.week', $this->path.'/'.$dbtype.'/prev.week'); } make_dirs( $this->path.'/'.$dbtype.'/last.week/', 0700); if ( !copy_recursive($this->path.'/'.$dbtype.'/current/'.$fname, $this->path.'/'.$dbtype.'/last.week/')) $this->log( CMMN_ERROR, STR_BACKUP_MAIL_HEADER, __FILE__, __LINE__, '', sprintf(STR_BACKUP_COPY_ERROR, $fname)); } if ( mwexec('rm -f '.$this->path.'/'.$dbtype.'/current/'.$old_fname.'*') != 0) $this->log( CMMN_ERROR, STR_BACKUP_MAIL_HEADER, __FILE__, __LINE__, '', STR_BACKUP_DEL_ERROR); } } ?>